/* $Id: StsAreaP.h,v 1.1.1.1 1997/08/24 07:17:15 frog Exp $ */

#ifndef	_HawStatusAreaP_h_
#define	_HawStatusAreaP_h_

#include	<X11/IntrinsicP.h>
#include	<X11/CoreP.h>
#include	<X11/ConstrainP.h>

#include	<Haw/StsArea.h>

typedef struct	_HawStatusAreaClassPart {
  XtPointer	extension;
} HawStatusAreaClassPart;

typedef struct	_HawStatusAreaClassRec {
  CoreClassPart			core_class;
  CompositeClassPart		composite_class;
  ConstraintClassPart		constraint_class;
  HawStatusAreaClassPart	status_area_class;
} HawStatusAreaClassRec;

extern HawStatusAreaClassRec	hawStatusAreaClassRec;


typedef struct	_HawStatusAreaPart
{
  Dimension		margin_width;
  Dimension		margin_height;
  Dimension		spacing;

  Window		parent_window;
  Cursor		cursor;
  Dimension		needed_width;
  Dimension		needed_height;
} HawStatusAreaPart;


typedef struct	_HawStatusAreaWidgetRec {
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  HawStatusAreaPart	status_area;
} HawStatusAreaWidgetRec;

#endif	/* _HawStatusAreaP_h_ */
