/* $Id: TextOut.h,v 1.4 1999/02/20 10:07:01 frog Exp $ */

#ifndef	_HawTextOut_h_
#define	_HawTextOut_h_

#include	<X11/Intrinsic.h>
#include	<X11/Xaw/Simple.h>
#include	<Haw/Haw.h>
#include	<Haw/HawStrDefs.h>
#include	"hcodec.h"

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 topLine	     TopLine		int		0
 value		     Value		String		NULL
 valueWcs	     HcsValue		HcsValue	""
 cursorPosition	     CursorPosition	Position	0
 displayCaret	     Output		Boolean		True
 columns	     Columns		short		dynamic
 blinkRate	     BlinkRate		int		0
 fontSet	     FontSet		XFontSet	XtDefaultFontSet
 foreground	     Foreground		Pixel		XtDefaultForeground
 focus		     Focus		Boolean		False
 maxLength	     MaxLength		int		MAXINT
 verifyBell	     VerifyBell		Boolean		True
*/

extern WidgetClass			hawwTextOutWidgetClass;

typedef struct _HawTextOutClassRec	*HawTextOutWidgetClass;
typedef struct _HawTextOutRec		*HawTextOutWidget;

#if defined(__cplusplus)  ||  defined(c_plusplus)
extern "C" {
#endif

extern Widget	HawCreateTextOut( Widget, char *, ArgList, Cardinal );
extern void	HawTextOutSetHighlight( Widget, Position, Position, HawHighlightMode );
extern Boolean	HawTextOutReplace( Widget, Position, Position, char * );
extern Boolean	HawTextOutReplaceHcs( Widget, Position, Position, hchar_t * );
extern void	HawTextOutInsert( Widget, Position, char * );
extern void 	HawTextOutInsertHcs( Widget, Position, hchar_t * );
extern void 	HawTextOutSetEditable( Widget, int );
extern void 	HawTextOutSetString( Widget, char *, HawHighlightMode );
extern void 	HawTextOutSetStringHcs( Widget, hchar_t *, HawHighlightMode );
extern void 	HawTextOutSetCursorPosition( Widget, Position );
extern char 	*HawTextOutGetString( Widget );
extern hchar_t	*HawTextOutGetStringHcs( Widget );
extern Position	HawTextOutGetLastPosition( Widget );

#if defined(__cplusplus)  ||  defined(c_plusplus)
}
#endif

#endif	/*_HawTextOut_h_ */
