/* $Id: XuiBitmap.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<X11/Intrinsic.h>
#include	<X11/xpm.h>

extern Widget	TopLevel;

/** @name Ʈ ó κ HimBitmap.c */
/*@{*/

/// Ƚ ũ⸦ ȯѴ.
void GetPixmapWHD(Display * dpy, Drawable d, Dimension *wth,
                  Dimension *hth, Dimension *dth)
{
    Window root;
    int x, y;
    unsigned int width, height, bw, depth;

    XGetGeometry(dpy, d, &root, &x, &y, &width, &height, &bw, &depth);
    if (wth != NULL)
        *wth = width;
    if (hth != NULL)
        *hth = height;
    if (dth != NULL)
        *dth = depth;
}

/// Xpm Ͽ pixmap .
Pixmap LoadXPM(char **xpmptr)
{
    XpmAttributes	xpmattr;
    Pixmap	pix;

    xpmattr.closeness = 2 << 15;
    xpmattr.valuemask = XpmCloseness;
    XpmCreatePixmapFromData(XtDisplay(TopLevel),
                            DefaultRootWindow(XtDisplay(TopLevel)),
                            xpmptr,
                            &pix, NULL, &xpmattr);
    return pix;
}

/*@}*/
