/* $Id: XuiIcon.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<X11/Intrinsic.h>
#include	<X11/Shell.h>
#include	<Haw/Haw.h>

#include	"hanim.h"
#include	"XuiBitmap.h"
#include	"bitmaps/hanIM.xpm"

typedef enum {
    HawICON_PIXMAP,
    HawICON_WINDOW
} HawIconMode;

static HawIconMode	icon_mode = HawICON_PIXMAP;
static Pixmap	icon = None;
static Window	icon_window = (Window) 0;

/** @name  ó κ HimIcon.c */
/*@{*/

///  Ѵ. ʱȭ ȴ.
void SetIcon( void )
{
    Display	*dpy = XtDisplay( TopLevel );
    Window	win;
    Dimension	width, height;

    icon = LoadXPM(hanIM_xpm);
    if ( icon != (Pixmap)0 )
        GetPixmapWHD(dpy, icon, &width, &height, NULL);

    if ( icon ) {
        if ( icon_mode == HawICON_WINDOW ) {
            win = XCreateSimpleWindow( dpy, DefaultRootWindow(dpy), 0, 0,
                                       width, height, 0,
                                       default_foreground, default_background );
            XSelectInput( dpy, win, StructureNotifyMask );
            XSetWindowBackgroundPixmap( dpy, win, icon );
            XClearWindow( dpy, win );
            XtVaSetValues( TopLevel, XtNiconWindow, win, NULL );
        } else
            XtVaSetValues( TopLevel, XtNiconPixmap, icon, NULL );
    }
    XtVaGetValues( TopLevel, XtNiconWindow, &icon_window, NULL );
}

///  쿡 ߻ϴ  󳽴.
Boolean	IconFilterEvent( XEvent	*event )
{
    Display *display = event->xany.display;

    if ( event->xany.window != icon_window )
        return( False );
    switch ( event->type ) {
    case MapNotify:
        if ( icon_mode == HawICON_WINDOW && icon_window != None ) {
            XSetWindowBackgroundPixmap( display, icon_window, icon );
            XClearWindow( display, icon_window );
        }
        break;
    }
    return( True );
}

/*@}*/
