/* $Id: buffer.h,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#ifndef _BUFFER_H_
#define _BUFFER_H_

#include "hanim.h"

/*@Man: Buffer ڷ */
/** Buffer ڷ Է ŬƮ ߰  Ҵϴ
  ڷ    Ǵ  ¸
  ϰ ִ. HimBuffer.c ۿ  Լ Ǿ
  ִ. ۴  ũ Ʈ Ǿ ־  ۳
   ۷ ̵  ִ.
  
  ʱȭ Ʈ    Է ۰ ,
   Ŭ̾Ʈ     ũ Ʈ
  ߰  ȴ.
  */
typedef struct _Buffer {
    ///  ۷ ̵Ѵ
    struct _Buffer	*prev;
    ///  ۷ ̵Ѵ
    struct _Buffer	*next;
    /// Ǿ ִ Ŭ̾Ʈ ̴.
    int	connect;
    /// X Է Ÿ Ѵ.
    unsigned long	xim_style;
    ///   ǰ
    Widget	preedit_widget;
    ///  ¸ Ÿ ǰ
    Widget	status_widget;
    Widget	label_widget;
    /// ̾˷α   ϴ 
    Widget	shell_widget;
    Widget	list_widget;

    ///   
    int	state;
    ///  Է   
    ConversionMode	conversion_mode;

    ///   Ʈ ġ 
    unsigned int	cursor;
    ///    Է ġ
    unsigned int	point;
    ///     Է ġ
    unsigned int	end_point;
    /// ڰ  Է 
    unsigned char	key[MAX_KEY];
    unsigned char	str[MAX_KEY];
    /// ڰ Է ǿ   
    unsigned int	keyC[MAX_KEY];
    /// ǿ ѱ۷ ȯ ڿԴϴ.
    hchar_t	hangul[MAX_HANGUL];
    /// ǿ ѱ۷ ȯ ڿ  
    unsigned int	hangulC[MAX_HANGUL];
    ConversionMode	mode[MAX_KEY];
    Boolean	conversion_flag[MAX_KEY];
    /// ڵǥ Է   
    unsigned short	ksc5601;
    /// ѱ 丶Ÿ ¸ Ÿ.
    struct hangul_automata_state hautomata;
} Buffer;

void	sort_buffer ( Buffer * );
Buffer	*set_buffer ( Widget, int );
void	buffer_initialize ( Buffer * );
Buffer	*buffer_alloc ( void );
void	buffer_free ( Buffer * );
void	pop_buffer ( Buffer * );
void	push_buffer ( Buffer * );
void	register_buffer ( Buffer * );
void	save_buffer ( Buffer * );
void	load_buffer ( Buffer * );

Boolean	insert_buffer( Buffer *, unsigned char, unsigned char, ConversionMode );
void	delete_character_buffer( Buffer *, Widget, hchar_t *, ConversionMode );
void	delete_word_buffer( Buffer *, Widget );

Boolean replace_hangul( Buffer *, hchar_t * );
Boolean add_hangul( Buffer *, hchar_t * );
Boolean complete_hangul( Buffer * );

#ifdef DEBUG
void	print_buffer(Buffer *b);
#endif

extern Buffer	*buffer, sys_buffer;

#endif /* _BUFFER_H_ */
