/* $Id: hanjadic.h,v 1.2 2000/01/11 01:28:46 frog Exp $ */

#ifndef _HANJADIC_H_
#define _HANJADIC_H_

#define	HANJA_NORMAL_END		0

/*
 *	hjdic_open error code
 */
#define	HANJA_CANNOT_OPEN_MDICT		(1 << 3)
#define	HANJA_CANNOT_OPEN_UDICT		(1 << 4)
#define	HANJA_CANNOT_OPEN_STUDY		(1 << 5)
#define	HANJA_CANNOT_MAKE_UDIR		(1 << 6)
#define	HANJA_CANNOT_MAKE_UDICT		(1 << 7)
#define	HANJA_CANNOT_MAKE_STUDY		(1 << 8)

/*
 *	hjdic_close error code
 */
#define	HANJA_NOT_OPENED_MDICT		(1 << 3)
#define	HANJA_NOT_OPENED_UDICT		(1 << 4)
#define	HANJA_NOT_OPENED_STUDY		(1 << 5)
#define	HANJA_CLOSE_MDICT_ERROR		(1 << 6)
#define	HANJA_CLOSE_UDICT_ERROR		(1 << 7)
#define	HANJA_CLOSE_STUDY_ERROR		(1 << 8)

/*
 *	hjdic_addterm error code
 */
#define	HANJA_DICT_ERROR		1
#define	HANJA_DICT_LOCKED		2
#define	HANJA_BAD_HANGUL_STR		3
#define	HANJA_BAD_HANJA_STR		4

#define	HANJA_WORD_EXIST		6
#define	HANJA_DICT_FULL			8
#define	HANJA_INDEX_FULL		9

#define	HANJA_WORD_NOT_EXIST		6

/*
 *	dummy
 */
#ifndef	HANJA_WORD_ID_SIZE
#define	HANJA_WORD_ID_SIZE		32
#endif

int hjdic_open ( char * );
int hjdic_close ( void );
int hjdic_gethanja ( hchar_t *, hchar_t *, int );
int hjdic_addterm ( hchar_t *, hchar_t *, int );
int hjdic_delterm ( hchar_t *, hchar_t *, int );
int hjdic_getdict ( hchar_t * );
int hjdic_nextdict ( hchar_t * );

#endif    /* _HANJADIC_H_ */
