/* $Id: hcodec.h,v 1.11 2000/01/11 01:28:46 frog Exp $ */

#ifndef	_HCODEC_H_
#define _HCODEC_H_

/* hchar_t  Ǵ wchar_t    ִ. */
#ifdef USE_JOHAB_CODE
typedef unsigned short	hchar_t;
#else
typedef wchar_t	hchar_t;
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#define	isksc(c)	((unsigned char)(c) >= 0xa1 &&		\
    (unsigned char)(c) <= 0xfe)
#define iskssmc(c)	((unsigned char)(c) >= 0x88 &&		\
    (unsigned char)(c) <= 0xfe)

extern int	ishangul( unsigned short );
extern int	ishangulalnum( unsigned short );
extern int	ishanguljamo( unsigned short );
extern int	ishanja ( unsigned short );
extern int	ishiragana( unsigned short );
extern int	iskatakana( unsigned short );
extern int	iscyrillic( unsigned short );

extern unsigned short	ksc2kssmc ( unsigned short );
extern unsigned short	kssmc2ksc ( unsigned short );
extern hchar_t	ksc2hc ( unsigned short );
extern hchar_t	kssmc2hc ( unsigned short );
extern unsigned short	hc2ksc( hchar_t hh );
extern unsigned short	hc2kssmc( hchar_t hh );
extern unsigned short	uc2ksc( hchar_t hh );
extern unsigned short	ksc2uc( hchar_t hh );

extern int	kss2kssms ( char *, char *, int );
extern int	kssms2kss ( char *, char *, int );
extern int	kssms2hcs ( hchar_t *, unsigned char *, int );
extern int	kss2hcs ( hchar_t [], char *, int );

extern int	mbtohc( hchar_t *hh, const char *in, size_t n);
extern int	hctomb( char *in, hchar_t hh);
extern size_t	mbstohcs( hchar_t *hs, const char *s, size_t n );
extern size_t	hcstombs( char *s, const hchar_t *hs, size_t n );

/* foreign language code conversion */
extern hchar_t	dvorakconv(unsigned short code);
extern hchar_t	qwertyconv(unsigned short code);
extern hchar_t	cyrillicconv(unsigned short code);
extern hchar_t	eng12conv ( unsigned short );
extern hchar_t	hiraganaconv(unsigned short code);
extern hchar_t	katakanaconv(unsigned short code);
extern void	hiras2katas ( hchar_t *, hchar_t [] );

#ifdef __cplusplus
}
#endif

#endif    /* _HCODEC_H_ */
