/* $Id: protowrap.c,v 1.6 2000/01/11 01:28:46 frog Exp $ */

#include	<X11/Xlib.h>
#include	"hanim.h"
#include	"Ximcp.h"
#include	"Ximp.h"

/** @name  ؼ κ */
/*@{*/

///  ڿ Ŭ̾Ʈ Ѵ.
Boolean SendCompoundText(Display *display, Window window, hchar_t *string)
{
#if defined(USE_XIMCP)
    if ( XimcpSendCompoundText( display, window, string ) )
        return( True );
#endif
#ifdef USE_XIMP
    if ( XimpSendCompoundText( display, window, string ) )
        return( True );
#endif
    return( False );
}

///  ó ¸ ȯѴ.
Boolean CheckState( State state )
{
#if defined(USE_XIMCP)
    if ( XimcpCheckState( state ) )
        return( True );
#endif
#ifdef USE_XIMP
    if ( XimpCheckState( state ) )
        return( True );
#endif
    return( False );
}

///   Ŭ̾Ʈ Ѵ.
Boolean SendKeyEvent(Window window, XKeyEvent *event)
{
#if defined(USE_XIMCP)
    if ( XimcpSendKeyEvent(window, event) )
        return( True );
#endif
#ifdef USE_XIMP
    if ( XimpSendKeyEvent(window, event) )
        return( True );
#endif
    return( False );
}

///  Ѵ.
void Disconnect( Display *display, Window window )
{
#ifdef USE_XIMP
    ximp_end( display, window );
#endif
}

/// ϵǾ ִ  ˻Ѵ.
Boolean IsRegisteredWindow( Protocol protocol, Window w1, Window w2 )
{
#ifdef USE_XIMP
    if ( protocol != XIM_PROTOCOL && XimpIsRegisteredWindow( w1, w2 ) )
        return( True );
#endif
    return( False );
}

Boolean PreeditChangeKeyDirection( XEvent *event )
{
#ifdef USE_XIMP
    if ( XimpPreeditChangeKeyDirection( event ) )
        return( True );
#endif
    return( False );
}

/// Ŭ̾Ʈ   ȴ.
Boolean ChangeDestroyNotify( XEvent *event )
{
#if defined(USE_XIMCP)
    if ( XimcpDestroyNotify( event ) )
        return( True );
#endif
#ifdef USE_XIMP
    if ( XimpDestroyNotify( event ) )
        return( True );
#endif
    return( False );
}

/// Expose  ȯѴ.
Boolean ChangeExpose( XEvent *event )
{
#if defined(USE_XIMCP)
    if ( XimcpChangeExpose( event ) )
        return( True );
#endif
#ifdef USE_XIMP
    if ( XimpChangeExpose( event ) )
        return( True );
#endif
    return( False );
}

/// Ŭ̾Ʈ ޼ ȯѴ.

Boolean ChangeClientMessage(XEvent *event)
{
#if defined(USE_XIMCP)
    if ( XimcpChangeClientMessage( event ) )
        return( True );
#endif
    return( False );
}

/*@}*/
