/* $Id: HanList.h,v 1.1.1.1 1997/08/24 07:17:15 frog Exp $ */

#ifndef _HanList_h_
#define _HanList_h_

#include	<X11/Xaw/Simple.h>
#include	<X11/Xaw/Form.h>
#include	<Haw/Haw.h>
#include	<Haw/HawStrDefs.h>

/* Resources:

 Name			    Class	     RepType	    Default Value
 ----			    -----	     -------	    -------------
 notifyCallback		    Callback	     XtCallbackList NULL
 setCallback		    Callback	     XtCallbackList NULL
 unsetCallback		    Callback	     XtCallbackList NULL
 browseSelectionCallback    Callback	     XtCallbackList NULL
 fontSet		    FontSet	     XFontSet	    -*-normal-*--16-*-*-*
 foreground		    Foreground	     Pixel	    XtDefaultForeground
 highlightAlways	    HighlightAlways  Boolean	    False;
 highlightThickness	    Thickness	     Dimension	    2
 horizDistance		    Thickness	     Int	    4
 itemArmColor		    ArmColor	     Pixel	    dynamic
 itemBaseHeight		    ItemBaseHeight   Dimension	    0
 itemBaseWidth		    ItemBaseWidth    Dimension	    0
 itemBackground		    Background	     Pixel	    XtDefaultBackground
 itemBorderWidth	    ItemBorderWidth  Dimension	    1
 itemCount		    ItemCount	     int	    0
 itemLength		    ItemLength	     int	    0
 items			    Items	     String	    NULL
 justify		    Justify	     Justify	    center
 marginHeight		    MarginHeight     Dimension	    2
 marginWidth		    MarginWidth	     Dimension	    2
 numColumns		    NumColumns	     short	    dynamic
 numRows		    NumRows	     short	    dynamic
 selectedItem		    SelectedItem     int	    dynamic
 vertDistance		    Thickness	     Int	    4
 visibleHorizontalItemCount VisibleItemCount int	    dynamic
 visibleVerticalItemCount   VisibleItemCount int	    dynamic
*/

extern WidgetClass	hawListWidgetClass;

typedef struct _HawListClassRec	*HawListWidgetClass;
typedef struct _HawListRec	*HawListWidget;

typedef struct {
  int		reason;
  XEvent	*event;
  int		item;
} HawListCallbackStruct, *HawListCallback;

#if defined(__cplusplus)  ||  defined(c_plusplus)
extern "C" {
#endif

extern Widget	HawCreateList( Widget, char *, ArgList, int );
extern Widget	HawCreateScrolledList( Widget, char *, ArgList, int );
extern Boolean	HawListSelectItem( Widget, int );
extern void	HawListPreviousItem( Widget );
extern void	HawListNextItem( Widget );
extern void	HawListUpItem( Widget );
extern void	HawListDownItem( Widget );
extern void	HawListPageUpItem( Widget );
extern void	HawListPageDownItem( Widget );
extern void	HawListTopItem( Widget );
extern void	HawListEndItem( Widget );
extern void	HawCvtStringToSourceCursorIconType( XrmValue *, Cardinal *,
						    XrmValue *, XrmValue * );
#if defined(__cplusplus)  ||  defined(c_plusplus)
}
#endif

#endif /* _HanIList_h_ */
