/* $Id: Haw.h,v 1.3 1999/02/20 10:07:01 frog Exp $ */

#ifndef _Haw_h_
#define _Haw_h_
#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<Haw/HawStrDefs.h>

#include	"hcodec.h"

#define	HawICON_DEFAULT_COLOR	0x1000000
#define HawICON_KEEP_COLOR	0x2000000

typedef enum {
  HawHIGHLIGHT_NORMAL,
  HawHIGHLIGHT_SELECTED,
  HawHIGHLIGHT_SECONDARY_SELECTED,
  HawHIGHLIGHT_TERTIARY_SELECTED
} HawHighlightMode;

typedef enum {
  HawCURSOR_LEFT,
  HawCURSOR_RIGHT
} HawCursorAttachment;

enum{
  HawCR_BROWSE_SELECT,
  HawCR_NOTIFY,
  HawCR_SET,
  HawCR_UNSET
};

typedef struct {
  char			ptr[32];
  hchar_t		hptr[32];
  int			length;
  HawHighlightMode	mode;
} HawTextBlockRec, *HawTextBlock;

typedef struct {
  int			reason;
  XEvent		*event;
  Boolean		doit;
  long			currInsert, newInsert;
  long			startPos, endPos;
  HawTextBlock		text;
} HawTextVerifyStruct, *HawTextVerifyPtr;

#endif  /* _Haw_h_ */
