# hanIM.spec file

%define xbindir /usr/X11R6/bin
%define xlibdir /usr/X11R6/lib

Name: hanIM
Version: 1.3
Release: 2
Summary: X11 Hangul Input Method Server
Copyright: free for personal use
Packager: Seo, Young-Jin <yjseo@mizi.co.kr>
Icon: icons/hanIM.gif
URL: http://www.mizi.co.kr
Vendor: Mizi Research Inc.
Source: hanIM-%{PACKAGE_VERSION}.tar.gz
Group: X11/IM
BuildRoot: /var/tmp/hanIM-root

%description
hanIM is a X11 Hangul Input Method Server.
hanIM supports RootWindow, OffTheSpot and OverTheSpot input methods.

%prep
%setup -D -c -a 0

rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin/X11
mkdir -p $RPM_BUILD_ROOT/usr/lib/X11/hanIM
mkdir -p $RPM_BUILD_ROOT/usr/lib/X11/app-defaults

%build
xmkmf
make Makefiles
make CCOPTIONS=-DNDEBUG

%install
make DESTDIR=$RPM_BUILD_ROOT install

%post
%postun

%files
%doc COPYING.MIZI samples TOTO
%config %{xlibdir}/X11/app-defaults/HanIM
%{xbindir}/hanIM
%{xlibdir}/X11/hanIM/hanroman.tbl
%{xlibdir}/X11/hanIM/japanese.tbl
%{xlibdir}/X11/hanIM/help

%changelog
* Tue Aug  12 1999 Seo, Young-Jin <yjseo@mizi.co.kr>
- dirty job for qt i18n

* Sat Aug  9 1999 Seo, Young-Jin <yjseo@mizi.co.kr>
- release 1.2-2
- event control flow is working.

* Sat Aug  9 1999 Seo, Young-Jin <yjseo@mizi.co.kr>
- release 1.2-1
- preference dialog is implemented, but event control flow is not working.
- Ϻ ȯ ״  - michi ġ backspce ġ  ׾
- Ϻ ȯ   Ʋ   
- Dvorak   Ű  ùٶ 
- Dvorak ǿ keypad ȯǴ  ذ
- ޴   toggle() ǵ 
-     action μ INTERMEDIATE PREEDIT 

* Thu Aug  5 1999 Seo, Young-Jin <yjseo@mizi.co.kr>
- 1.1 
- Xkb Dvorak   
- 3 Է½ keypad ѱ۷ ٲ  
- ѱ Է½ CapsLock Shift ˻
-  α׷ 鹬 ۲ ϰ 
   xfntmizi Ű ʿ.
- Preference resource is cleared.
