/* $Id: hangul.h,v 1.5 2000/01/11 01:28:45 frog Exp $ */

#ifndef _HANGUL_H_
#define _HANGUL_H_

/* ϴϸ Emacs ѱ   ֵ  Emacs  Դϴ.
   Copyright (C) 1994, 95, 96 ϴϸ  (fpf545@dosa1.snu.ac.kr).
 
   Emacs ҽ ڵ忡 ѱ ó   κ hanemacs 
   ũθ ϰ ֽϴ.  κ   ȭϰ Բ 
   ϴϸ ҽ ڵ ֵ˴ϴ.
 
HanEmacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.
 
HanEmacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


enum char_kind { ck_error, ck_ascii, ck_han1, ck_han2 };

/* value assigned to 'CDstate' */
enum code_result
{
    code_nokey, code_ascii, code_hanst, code_hanin,
    code_hanend, code_hanbs, code_nohan, code_delete
};

struct hangul_automata_state
{
    int han_kbd_kind;   	/* default 3 bulsik */
    int han_kbd_state;   	/* default Hangul */
    struct input_stack
    {
        int amstate;
        unsigned key;
        unsigned code;
    } input_stack[10];
    int input_sp;
    unsigned output_stack[5];
    int output_sp;
    int AMstate;    /* most recent value of input_stack[].amstate */
    int CDstate;    /* state of resulting code */
};

#define COMB_STATE(h)	(h.AMstate)

enum johab_state
{
    johab_chosung, johab_jungsung, johab_jongsung,
    johab_only_jungsung, johab_only_jongsung
};

#define MAX_XC2bBUF 200
#define MAX_CKCACHE 400

void	init_hangul_automata ( struct hangul_automata_state * );
void	clear_hangul_automata ( struct hangul_automata_state * );
void	set_global_hangul_keyboard( int );
int	get_hangul_code ( struct hangul_automata_state *, unsigned short,
                                  unsigned short *, unsigned short *s);

#endif    /* _HANGUL_H_ */
