/* $Id: hstring.h,v 1.4 2000/01/11 01:28:46 frog Exp $ */

#ifndef _HSTRING_H_
#define _HSTRING_H_

#include <stdlib.h>

#ifdef __cplusplus
extern "C"
{
#endif

    extern hchar_t	*hcscat ( hchar_t *, const hchar_t * );
    extern hchar_t	*hcscpy ( hchar_t *, const hchar_t * );
    extern hchar_t	*hcsncpy ( hchar_t *, const hchar_t *, size_t );
    extern hchar_t	*hcsncat ( hchar_t *, const hchar_t *, size_t );
    extern hchar_t	*hcschr ( const hchar_t *, hchar_t );
    extern hchar_t	*hcsrchr ( const hchar_t *, hchar_t );
    extern hchar_t	*hcspbrk ( const hchar_t *, const hchar_t *);
    extern hchar_t	*hcstok ( hchar_t *, const hchar_t * );
    extern hchar_t	*hcsdup( const hchar_t * );

    extern int	hcscmp ( const hchar_t *, const hchar_t * );
    extern int	hcsncmp ( const hchar_t *, const hchar_t *, size_t );
    extern size_t	hcsspn( const hchar_t *, const hchar_t * );
    extern size_t	hcslen ( const hchar_t * );

#ifdef __cplusplus
}
#endif

#endif    /*_HSTRING_H_ */
