/* $Id: resource.h,v 1.11 2000/01/11 01:28:46 frog Exp $ */

#ifndef	_RESOURCE_H_
#define	_RESOURCE_H_

#include	"hanim.h"
#include	"Ximp.h"

typedef struct {
    /* recources */
    XtTranslations	accelerators;
    XtTranslations	base_accelerators;
    String		hanIM;

    CharacterCode	code;
    InputLanguage	lang;

    HangulKeyboard	hangul_keyboard;
    EnglishKeyboard	english_keyboard;
#if 0 /* LATER */
    JapaneseKeyboard	japanese_keyboard;
#endif    /* LATER */
    /*   ҽ , ǿ  . */
    ConversionMode	initial_mode;
    /* button labels */
    String	button_label[6];
    String	rootwin_label[4];
    String	ok_label;
    String	cancel_label;
    String	close_label;
    /*   ̸ -   ǥ  */
    String	hangul_3bulsik;
    String	hangul_2bulsik;
    String	english_qwerty;
    String	english_dvorak;
    String	japanese_eng_hiragana;
    String	japanese_eng_katakana;
    String	japanese_hiragana;
    String	japanese_katakana;
    String	cyrillic_mode;
#if 0 /* LATER */
    String	hangul_roman;
    String	japanese_han_hiragana;
    String	japanese_han_katakana;
#endif    /* LATER */
    /*  ̸ */
    String	euckr;
    String	kssm;
    String	ucs2;
    String	ksc5601;
    /* error messages */
    String	ask_quit;
    String	ask_restart;
    String	unimplemented;
    String	malloc_error;
    String	died_error;
    String	open_error1;
    String	open_error2;
    String	open_error3;
    String	open_error4;
    String	open_error5;
    String	open_error6;
    String	open_error7;
    String	close_error1;
    String	close_error2;
    String	close_error3;
    String	close_error4;
    String	close_error5;
    String	close_error6;
    String	close_error7;
    String	close_error8;
    String	add_error1;
    String	add_error2;
    String	add_error3;
    String	add_error4;
    String	add_error5;
    String	add_error6;
    String	add_error7;
    String	delete_error1;
    String	delete_error2;
    String	delete_error3;
    String	delete_error4;
    String	delete_error5;
    String	delete_error6;
    String	learning_error1;
    String	learning_error2;
    String	conversion_error1;
    XimpKey	*process_start_keys;
    /* Ÿ ҽ о  */
    String	hjdic;
    int		xim_protocol;
    Boolean	ximc_protocol;
    Boolean	auto_replace;
    Boolean	ignore_preedit_color;
    Boolean	ignore_status_color;
    Boolean	conversion_message;
    Boolean	reset_message;
    Boolean	auto_raise;
    Boolean	ghost_mode;
    long	debug;
} HanIM;

extern HanIM	resources;
extern Boolean	is_started_key ( XKeyEvent * );

#endif   	/* _RESOURCE_H_ */
