/* $Id: romandic.h,v 1.6 2000/01/11 01:28:46 frog Exp $ */

#ifndef _ROMANDIC_H_
#define _ROMANDIC_H_

typedef struct _RomanTable {
    struct _RomanTable	*previous;
    struct _RomanTable	*next;
    unsigned char	*key;
    hchar_t	*hangul;
    unsigned char	*str;
} RomanTable;

void	init_roman_tables(void);

#if 0 /* LATER */
RomanTable	*han_forward_search ( char * );
RomanTable	*han_forward_sub_search ( char * );
RomanTable	*han_backward_sub_search ( char * );
#endif    /* LATER */

RomanTable	*jp_forward_search ( char * );
RomanTable	*jp_forward_sub_search ( char * );
RomanTable	*jp_backward_sub_search ( char * );

#endif    /* _ROMANDIC_H_ */
